BuffDepak   EQU     #B000
AdrPolice   EQU     #A800               ; Doit tre divisible par 256

	ORG	#9C00
	read	"mode11.asm"

debut:
        LD      A,(#A700)
        PUSH    AF
        LD      C,7
        LD      DE,#40
        LD      HL,#ABFF
        CALL    #BCCE                   ; Initalisation ROM DISC
        POP     AF
        LD      (#A700),A
	LD      A,1
        CALL    #BC0E
	LD	BC,#BC06
        XOR     A
	OUT	(C),C
	INC	B
	OUT	(C),A
	LD	HL,DefPAL
BcCol:
	PUSH	AF
	PUSH	HL
	LD	C,(HL)
	LD	B,C
        CALL    #BC32
        POP     HL
	INC	HL
	POP	AF
	INC	A
	CP	4
	JR	C,BcCol
	LD	BC,0
        CALL    #BC38
	LD	HL,#9C00
	LD	DE,#C000
	LD	BC,#800
	LDIR

        LD      IX,TabBank
BclLect:
        LD      B,#7F
        LD      A,(IX+0)
        AND     A
        JR      Z,Play
        OUT     (C),A
        LD      HL,NomFic
        LD      B,12
        LD      D,(IX+2)
        LD      E,(IX+1)
        PUSH    DE
        CALL    #BC77
Err1:
	JR	NC,Err1
        POP     HL
        CALL    #BC83
        CALL    #BC7A
        LD      HL,NumFic
        INC     (HL)
        INC     IX
        INC     IX
        INC     IX
        JR      BclLect

Play:
        DI
        LD      HL,#C000
        LD      DE,AdrPolice
        LD      BC,#800
        LDIR
        LD      HL,NewIt
        LD      (#39),HL
        EI
	LD	BC,#BC06
        LD      A,25
	OUT	(C),C
	INC	B
	OUT	(C),A
Play2:
        LD      HL,#C000
        LD      DE,#C001
        LD      BC,#3FFF
        LD      (HL),L
        LDIR
        LD      HL,TabBank
BclBank:
        LD      A,(HL)
        AND     A
        JR      Z,Play2
        LD      B,#7F
        OUT     (C),A
        INC     HL
        LD      A,(HL)
        INC     HL
        PUSH    HL
        LD      H,(HL)
        LD      L,A
BclImg:
        XOR     A
        LD      (Cnt+1),A
        CALL    DepactImg
WaitImg:
        LD      A,(Cnt+1)
        CP      12
        JR      C,WaitImg
        LD      A,H
        OR      L
        JR      NZ,BclImg
        POP     HL
        INC     HL
        JR      BclBank
;
; HL = adresse image  decompacter
; retour HL = adresse image suivante ou 0
;
DepactImg:
        LD      A,(HL)
        INC     HL
        OR      (HL)
        DEC     HL
        AND     A
        JR      Z,FinImg2
        LD      DE,BuffDepak
        CALL    DepkLzw
        INC     HL
        PUSH    HL
        LD      IX,BuffDepak
Boucle:
        LD      DE,#C000
        LD      A,(IX+0)
        AND     A
        JR      Z,FinImg
        INC     IX
        CP      'O'
        JR      Z,DrawImgO
        CP      'D'
        JR      Z,DrawImgD
        POP     HL
        RET
FinImg:
        POP     HL
FinImg2:
        LD      HL,0
        RET

DrawImgO:
        LD      BC,AdrPolice
        LD      H,C
        LD      L,(IX+0)
        INC     IX
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,BC
        LD      B,#11
        LD      A,D
        LDI
        DEC     DE
        SET     3,D
        LDI
        DEC     DE
        ADD     A,B
        LD      D,A
        LDI
        DEC     DE
        SET     3,D
        LDI
        DEC     DE
        ADD     A,B
        LD      D,A
        LDI
        DEC     DE
        SET     3,D
        LDI
        DEC     DE
        ADD     A,B
        LD      D,A
        LDI
        DEC     DE
        SET     3,D
        LDI
        LD      HL,#C800
        ADD     HL,DE
        EX      DE,HL
        LD      A,D
        CP      #C7
        JR      NZ,DrawImgO
        LD      A,E
        CP      #D0
        JR      NZ,DrawImgO
        POP     HL
        RET

DrawImgD:
        LD      C,(IX+0)
        INC     IX
        LD      B,(IX+0)
        INC     IX
DrawImgD1:
        PUSH    BC
        LD      C,(IX+0)                        ; Dplacement
        INC     IX
        LD      B,0
        EX      DE,HL
        ADD     HL,BC
        EX      DE,HL
        LD      H,B
        LD      L,(IX+0)                        ; Code ASCII
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,HL
        LD      BC,AdrPolice
        ADD     HL,BC
        LD      B,#11
        LD      A,D
        LDI
        DEC     DE
        SET     3,D
        LDI
        DEC     DE
        ADD     A,B
        LD      D,A
        LDI
        DEC     DE
        SET     3,D
        LDI
        DEC     DE
        ADD     A,B
        LD      D,A
        LDI
        DEC     DE
        SET     3,D
        LDI
        DEC     DE
        ADD     A,B
        LD      D,A
        LDI
        DEC     DE
        SET     3,D
        LDI
        LD      HL,#C800
        ADD     HL,DE
        EX      DE,HL
        INC     IX
        POP     BC
        DEC     BC
        DEC     BC
        LD      A,B
        OR      C
        JR      NZ,DrawImgD1
        POP     HL
        RET

;
; Entre :
;
;   HL = Buffer (fichier compact)
;   DE = Destination
;
; Sortie :
;
;   AF, BC, DE, HL modifis
;
;
DepkLzw:
        XOR     A
        LD      (BclLzw+1),A
BclLzw:
        LD      A,0
        RR      A                   ; Rotation avec calcul Flags C et Z
        LD      (BclLzw+1),A
        JR      Z,TstBitLzw
        JR      C,TstCodeLzw

        LDI
        JR      BclLzw
;
TstBitLzw:
        LD      A,(HL)
        INC     HL
        RRA                         ; Rotation rapide calcul seulement flag C
        SET     7,A                 ; Positionne bit 7 en gardant flag C
        LD      (BclLzw+1),A
        JR      C,TstCodeLzw

        LDI
        JR      BclLzw

;
TstCodeLzw:
;
;       a = inbuffer[ inbytes ];
;
        LD      A,(HL)
        AND     A
;
; Plus d'octets  traiter
; = fini
;
        RET     Z

        INC     HL
        LD      B,A
TstLzw80:
        RLCA
        JR      NC,TstLzw40
;
;       length = 3 + ( ( inbuffer[ inbytes ] >> 4 ) & 7 );
;       index = ( inbuffer[ inbytes++ ] & 15 ) << 8;
;       index |= inbuffer[ inbytes++ ];
;       index++;
;
        PUSH    HL
        LD      L,(HL)
        LD      C,B
        RLCA
        RLCA
        RLCA
        AND     7
        ADD     A,3
        LD      B,A
        LD      A,C
        AND     #0F
        LD      H,A
        LD      C,B
        LD      B,0
        INC     HL
        PUSH    DE
        EX      DE,HL
        SBC     HL,DE
        POP     DE
        LDIR
        POP     HL
        INC     HL
        JR      BclLzw
;
TstLzw40:
        RLCA
        JR      NC,TstLzw20
;
;       length = 2;
;       index = inbuffer[ inbytes++ ] & 0x3f;
;       index++;
;
        LD      A,B
        PUSH    HL
        AND     #3F
        LD      L,A
        LD      H,0
        INC     L
        LD      B,D
        LD      C,E
        EX      DE,HL
        SBC     HL,DE
        LD      D,B
        LD      E,C
        LDI
        LDI
        POP     HL
        JR      BclLzw
;
TstLzw20:
        RLCA
        JR      NC,TstLzw10
;
;       length = 2 + ( inbuffer[ inbytes++ ] & 31 );
;       index = inbuffer[ inbytes++ ];
;       index++;
;
        PUSH    HL
        LD      A,B
        LD      L,(HL)
        AND     #1F
        ADD     A,2
        LD      C,A
        LD      H,0
        LD      B,H
        INC     HL
        PUSH    DE
        EX      DE,HL
        SBC     HL,DE
        POP     DE
        LDIR
        POP     HL
        INC     HL
        JR      BclLzw
;
TstLzw10:
        RLCA
        JR      NC,CodeLzw00
;
;       index = ( inbuffer[ inbytes++ ] & 15 ) << 8;
;       index |= inbuffer[ inbytes++ ];
;       length = inbuffer[ inbytes++ ] + 1;
;       index++;
;
        LD      A,B
        AND     #0F
        LD      B,(HL)
        INC     HL
        PUSH    HL
        LD      C,(HL)
        LD      H,A
        LD      L,B
        LD      B,0
        INC     BC
        INC     HL
        PUSH    DE
        EX      DE,HL
        SBC     HL,DE
        POP     DE
        LDIR
        POP     HL
        INC     HL
        JP      BclLzw
;
CodeLzw00:
        PUSH    HL
        LD      A,B
        CP      15
        JR      NZ,CodeLzwN15
;
;       length = index = inbuffer[ inbytes+1 ] + 1;
;       inbytes += 2;
;
        LD      C,(HL)
        XOR     A
        LD      B,A
        INC     BC
        LD      H,B
        LD      L,C
        PUSH    DE
        EX      DE,HL
        SBC     HL,DE
        POP     DE
        LDIR
        POP     HL
        INC     HL
        JP      BclLzw
;
CodeLzwN15:
        CP      2
        JR      C,CodeLzwInf2
;
;       length = index = inbuffer[ inbytes ];
;
        LD      C,A
        LD      L,A
        XOR     A
        LD      H,A
        LD      B,H
        PUSH    DE
        EX      DE,HL
        SBC     HL,DE
        POP     DE
        LDIR
        POP     HL
        JP      BclLzw
;
;       length = index = 256;
;
CodeLzwInf2:
        XOR     A
        LD      B,A
        LD      C,A
        INC     B
        LD      H,B
        LD      L,C
        PUSH    DE
        EX      DE,HL
        SBC     HL,DE
        POP     DE
        LDIR
        POP     HL
        JP      BclLzw

;
; Nouvelle routine d'interruption, incrmente simplement un compteur
;
NewIt:
        PUSH    AF
Cnt:
        LD      A,0
        INC     A
        LD      (Cnt+1),A
        POP     AF
        EI
        RET

;
NomFic:
        DB      "FLAM    .BK"
NumFic:
        DB      "0"

;
; O charger les fichiers, numro de banque et adresse
;
TabBank:
        DB      #C0
        DW      #0040
        DB      #C4
        DW      #4000
        DB      #C5
        DW      #4000
        DB      #C6
        DW      #4000
        DB      #C7
        DW      #4000
        DB      0
DefPal:
	DB	0,24,2,6
